Package org.h2.api

# Interface Aggregate

All Known Implementing Classes:
  `Aggregate1`, `TestFunctions.MedianStringType`, `TestSpatial.TableEnvelope`

public interface Aggregate
A user-defined aggregate function needs to implement this interface. The class must be public and must have a public non-argument constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`add(Object value)`
This method is called once for each row.
`int`
`getInternalType(int[] inputTypes)`
This method must return the H2 data type, `Value`, of the aggregate function, given the H2 data type of the input data.
`Object`
`getResult()`
This method returns the computed aggregate value.
`default void`
`init(Connection conn)`
This method is called when the aggregate function is used.

## Method Details

### init

default void init(Connection conn) throws SQLException
This method is called when the aggregate function is used. A new object is created for each invocation.

Parameters:
  `conn` - a connection to the database
Throws:
  `SQLException` - on SQL exception

### getInternalType

int getInternalType(int[] inputTypes) throws SQLException
This method must return the H2 data type, `Value`, of the aggregate function, given the H2 data type of the input data. The method should check here if the number of parameters passed is correct, and if not it should throw an exception.

Parameters:
  `inputTypes` - the H2 data type of the parameters,
Returns:
  the H2 data type of the result
Throws:
  `SQLException` - if the number/type of parameters passed is incorrect

### add

void add(Object value) throws SQLException
This method is called once for each row. If the aggregate function is called with multiple parameters, those are passed as array.

Parameters:
  `value` - the value(s) for this row
Throws:
  `SQLException` - on failure

### getResult

Object getResult() throws SQLException
This method returns the computed aggregate value. This method must preserve previously added values and must be able to reevaluate result if more values were added since its previous invocation.

Returns:
  the aggregated value
Throws:
  `SQLException` - on failure